package com.wechi.adweb.bridge.google.analytics.dto.report;

import static com.wechi.adweb.bridge.google.analytics.dto.report.GAReportRequestDTO.OrderByType.*;
import static com.wechi.adweb.bridge.google.analytics.dto.report.ReportConstant.*;

import lombok.Getter;

import java.util.List;

/**
 * @author wfansh
 */
@Getter
public enum ReportType {
    ADWEB_COUNTRY_CHART(List.of(METRIC_TOTAL_USERS), List.of(DIMENSION_COUNTRY)),
    ADWEB_SESSION_SOURCE_MEDIUM_VIEW(
            List.of(
                    METRIC_TOTAL_USERS,
                    METRIC_NEW_USERS,
                    METRIC_SESSIONS,
                    METRIC_BOUNCE_RATE,
                    METRIC_AVG_SESSION_DURATION,
                    METRIC_SCREEN_PAGE_VIEWS_PER_SESSION),
            List.of(DIMENSION_SESSION_SOURCE_MEDIUM)),
    ADWEB_PAGE_PATH_VIEW(
            List.of(
                    METRIC_ENGAGEMENT_RATE,
                    METRIC_SCREEN_PAGE_VIEWS,
                    METRIC_USER_ENGAGEMENT_DURATION),
            List.of(DIMENSION_PAGE_PATH),
            METRIC_SCREEN_PAGE_VIEWS,
            METRICS,
            true),
    PAGE_VIEWS(
            List.of(METRIC_SCREEN_PAGE_VIEWS),
            List.of(DIMENSION_DATE),
            DIMENSION_DATE,
            DIMENSIONS,
            false);

    ReportType(List<String> defaultMetrics, List<String> defaultDimensions) {
        this.defaultMetrics = defaultMetrics;
        this.defaultDimensions = defaultDimensions;
        this.defaultOrderBy = null;
        this.defaultOrderByType = null;
        this.defaultOrderByDesc = false;
    }

    ReportType(
            List<String> defaultMetrics,
            List<String> defaultDimensions,
            String defaultOrderBy,
            GAReportRequestDTO.OrderByType defaultOrderByType,
            boolean defaultOrderByDesc) {
        this.defaultMetrics = defaultMetrics;
        this.defaultDimensions = defaultDimensions;
        this.defaultOrderBy = defaultOrderBy;
        this.defaultOrderByType = defaultOrderByType;
        this.defaultOrderByDesc = defaultOrderByDesc;
    }

    private final List<String> defaultMetrics;
    private final List<String> defaultDimensions;
    private final String defaultOrderBy;
    private final GAReportRequestDTO.OrderByType defaultOrderByType;
    private final Boolean defaultOrderByDesc;
}
