package com.wechi.adweb.bridge.google.analytics;

import com.google.gson.Gson;
import com.wechi.adweb.bridge.exception.DataException;
import com.wechi.adweb.bridge.google.analytics.dto.report.GAReportRequestDTO;
import com.wechi.adweb.bridge.google.analytics.dto.report.ReportType;

import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

@SpringBootTest
public class GAServiceTests {

    @Autowired private GAAdminService gaAdminService;
    @Autowired private GADataService gaDataService;

    private final String propertyName = "properties/457183952";
    private final String startDate = "2023-10-01";
    private final String endDate = "2024-10-01";
    private final Gson gson = new Gson();

    @Test
    void runReport() throws DataException {

        // 1. Country chart.
        GAReportRequestDTO reportRequest = new GAReportRequestDTO();
        reportRequest.setPropertyName(propertyName);
        reportRequest.setReportType(ReportType.ADWEB_COUNTRY_CHART);
        reportRequest.setStartDate(startDate);
        reportRequest.setEndDate(endDate);
        System.out.println(gson.toJson(gaDataService.runReport(reportRequest)));

        // 2. Session source medium view.
        reportRequest = new GAReportRequestDTO();
        reportRequest.setPropertyName(propertyName);
        reportRequest.setReportType(ReportType.ADWEB_SESSION_SOURCE_MEDIUM_VIEW);
        reportRequest.setStartDate(startDate);
        reportRequest.setEndDate(endDate);
        System.out.println(gson.toJson(gaDataService.runReport(reportRequest)));

        // 3. Page path view.
        reportRequest = new GAReportRequestDTO();
        reportRequest.setPropertyName(propertyName);
        reportRequest.setReportType(ReportType.ADWEB_PAGE_PATH_VIEW);
        reportRequest.setStartDate(startDate);
        reportRequest.setEndDate(endDate);
        System.out.println(gson.toJson(gaDataService.runReport(reportRequest)));

        // 4. Page views.
        reportRequest = new GAReportRequestDTO();
        reportRequest.setPropertyName(propertyName);
        reportRequest.setReportType(ReportType.PAGE_VIEWS);
        reportRequest.setStartDate(startDate);
        reportRequest.setEndDate(endDate);
        System.out.println(gson.toJson(gaDataService.runReport(reportRequest)));
    }
}
